#include <allegro.h>
#include <iostream.h>
#include <stdlib.h>

#include "battle.h"
#include "gameconsts.h"
#include <algorithm>
#include "optionsMenu.h" // only for itoa, needs to move
#include "dialogBox.h"


// Draws the a scrollable view, returns a string with the item selected when action was hit
string inventoryBox(int posX = 40, int posY = 40, int itemsInView = 4)
{
	itemList currentItems = hero.GetItems();
	std::itemList::iterator pos, selection, startPos;	
	vector<string> textVect;
	int items = 0;
	pos = currentItems.begin();
	selection = pos;	startPos = pos;
	textVect.clear();
	textVect.push_back("   ~~INVENTORY~~   ");
	textVect.push_back(" ");	
	int listPos = 0;
	if (currentItems.begin() == currentItems.end())
	{	textVect.push_back("No Items"); TextBox(textVect, posX, posY); while (!key[ACTION_KEY] && !key[CANCEL_KEY]) vsync();
		while (key[ACTION_KEY] || key[CANCEL_KEY]) vsync(); return "";
	}
	else
	{
		for(items=0, pos = startPos; pos != currentItems.end() && items<itemsInView; pos++, items++)
		{
			if (selection == pos) { cout << "<>" << endl; textVect.push_back(">" + *pos + "<");}
			else {cout << " " << endl; textVect.push_back(*pos); }
			cout << *pos << endl;
		}
		for (; items < itemsInView; items++) { textVect.push_back(""); }
		TextBox(textVect, posX,posY);
		while (!key[ACTION_KEY] && !key[CANCEL_KEY])
		{
			if (key[KEY_UP] || key[KEY_DOWN])
			{	 // back to begining of list			
				if (key[KEY_UP])	
				{	
					if (selection != currentItems.begin())
					{ 
						if (listPos > 1) 	listPos--; 
						else if (startPos != currentItems.begin()) 
						{		startPos--;}
						selection--; 
					}
				}
				if (key[KEY_DOWN])	
				{	
					selection++;
					if (selection != currentItems.end()) 
					{ 	 
						if (listPos != itemsInView)	listPos++;
						else if (startPos != currentItems.end())
						{	startPos++;	} 
					}
					else selection--;
				}
				textVect.clear();
				textVect.push_back("   ~~INVENTORY~~   ");
				textVect.push_back(" ");
				for(items=0, pos = startPos; pos != currentItems.end() && items<itemsInView; pos++, items++)
				{
					if (selection == pos) { textVect.push_back(">" + *pos + "<");}
					else textVect.push_back(*pos);
				}
				for (; items < itemsInView; items++) { textVect.push_back(""); }
				TextBox(textVect, posX, posY);
				if (key[KEY_UP] || key[KEY_DOWN]){for(int delay=0; delay<20; delay++)vsync();}// delay
			}
		}	
		cout << "The word of the day is... " << *selection << endl;
		if (key[CANCEL_KEY]) return "";
		return *selection;
	}
	TextBox(textVect, posX, posY);
}


void randBattle()
{	// Need to determine where on the map the character is at.

	if (rand()%10000 < attackProb[mapTileData[X/32][Y/32]])
	{
		cout << X/32 << ", " << Y/32 << endl;
		cout << "Initializing battle" << endl;
		if (Y < 32*32 || X > 96*32)
		{	// You are in a city
			
			return;
		}
		Battle battle1;
		if (Y > 80 *32)
		{	
			cout << enemyList[0].GetName() << endl;
			battle1.SetEnemies(enemyList[0]);
		}
		else if (Y > 50*32)
		{	
			cout << enemyList[1].GetName() << endl;
			battle1.SetEnemies(enemyList[1]);
		}
		else
		{
			cout << enemyList[2].GetName() << endl;
			battle1.SetEnemies(enemyList[2]);
		}
		battle1.BeginBattle();
	
		cout << "Exiting battle" << endl;
		
		/*Battle battle1;
		cout << enemyList[0].GetName() << endl;
		battle1.SetEnemies(enemyList[0]); // Need to make this pos dependent
		battle1.BeginBattle();
		cout << "Exiting battle" << endl; */
	}
}



void Battle::SetEnemies(Enemy in1)  // only allowing one enemy
{	enemies = in1;	}

int Battle::BeginBattle()
{
	bool EnemiesTurn = 1;
	bool Finish = 0;
	int attackee = 0;
	int attacker = 0;
	int textColor = 4;
	heros[0] = &hero; //????!!!!
	totalHeros=1;
	cout <<  "Into the battle" << endl;
	BITMAP* backdrop, *backup;
	
	backdrop=create_bitmap(SCREEN_HEIGHT, SCREEN_WIDTH);
	backup  =create_bitmap(SCREEN_HEIGHT, SCREEN_WIDTH);
	backdrop=load_bitmap("battleback.bmp",default_palette);

	blit(backdrop, screen, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT); // put background on screen
	clear(framebuf);

/// Draw characters onto the view
	//	draw_sprite(screen,(BITMAP *)data[map].dat,  0,0); 
	blit(mainMap, framebuf, 96, 0, 100, 500, 32, 32);
	blit(mainMap, framebuf, 32, 0, 400, 500 , 32, 32);
	
/// end draw

	int option = 0;
	int activeCharacter = 0;
	int optionSelected = 0;
//	int optionActive = 0; // which option is highlighted
	int whoToAttack = 0;
	blit(backdrop, framebuf, 0,0,0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	int damage = 0;
	string damageS;
	vector <string> textVect;
	while (!Finish && !key[KEY_ESC])// enemies are alive or heros are alive
	{
		blit(mainMap, framebuf, 96, 0, 100, 300, 32, 32);
		blit(mainMap, framebuf, 32, 0, 500, 300 , 32, 32);
		blit(framebuf, screen, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT);
		vsync();
		textout_centre(framebuf, font , enemies.GetName().c_str(), 90, 20, 23 );	
		blit(framebuf, backup, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT);
		
		////////////////////
	  /////  ALWAYS MAKE THE USER STATS AT THE BOTTOM
		textVect.clear();
		textVect.push_back(" " + heros[0]->GetName() + " ");
		textVect.push_back("");
		textVect.push_back("  HP: " + itoa(heros[0]->GetHP()) + "/" + itoa(heros[0]->GetMaxHP()));
		textVect.push_back("  MP: " + itoa(heros[0]->GetMP()) + "/" + itoa(heros[0]->GetMaxMP()));
		TextBox(textVect, 80, SCREEN_HEIGHT-100);
	  /////  END OF USER STATS SECTION
		////////////////////
		
		poll_joystick();
		if (key[KEY_UP]   || joy_up) { if (option > 0) option--; while(key[KEY_UP]) vsync();}
		if (key[KEY_DOWN] || joy_down){if (option < 3) option++; while(key[KEY_DOWN]) vsync();}
		
		if (EnemiesTurn == 0)
		{
			cout << ":Computer Attacks Player " << attackee;//
			attackee = 0;// for now!!!  attackee will be more?  rand() % totalHeros;
			attacker = 0;

			cout << ":Computer Attacks Player " << attackee << endl;//
			damage = heros[attackee]->defend(enemies.attack());
			if (heros[attackee]->GetHP() == 0) Finish = true;
		
			damageS = itoa(damage);	
			for (int pos = 0; pos < 60; pos++)
			{
				vsync();vsync();
				blit(framebuf, screen, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT);
				textout(screen, font, damageS.c_str(), (535)+(int)pos/3, 280-(int)pos/2, makecol(255,255,255));
			}			
			EnemiesTurn = 1;
		}
		else // Players turn
		{
		////////////////////
	  /////  PLAYER MOVE OPTIONS
	  	textVect.clear();
	  		// for speed, unwraped loop
	  	textVect.push_back("   ");textVect.push_back("   ");textVect.push_back("   ");textVect.push_back("   ");
	  	textVect[option] = " > ";
		textVect[0] += "Attack";textVect[1] += "Item  ";
		textVect[2] += "Magic ";textVect[3] += "Escape";
		textVect[option] += " < ";
		TextBox(textVect, 460, SCREEN_HEIGHT-100);
	  /////  END OF USER STATS SECTION
		////////////////////
			
		
		if (key[ACTION_KEY])
		{
			while (key[ACTION_KEY]) vsync();
			vsync();
			
			blit(framebuf, screen, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT); // Is this okay, is there missing info at all?
			
			if (option == 0) // this is the attack option
			{
				cout << "Player Attacking " << endl;
				damage = enemies.defend(heros[attacker]->attack());
				damageS = itoa(damage);
				for (int pos = 0; pos < 60; pos++)
				{
					vsync();vsync();
					blit(framebuf, screen, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT); // Is this okay, is there missing info at all?
					textout(screen, font, damageS.c_str(), 140+(int)pos/3, 280-(int)pos/2, makecol(255,255,255));
				}
				EnemiesTurn = 0;
			}
			else if (option == 1) // Use item
			{  // Show items list??
				string selection = inventoryBox();
				if (selection != "") 
				{	hero.UseItem(selection); EnemiesTurn = 0; }
			
			}
			else if (option == 2) // Use magic
			{  // Show items list?? // tHis is itme sthuff, needs replacement
				string selection = inventoryBox();
				if (selection != "")
				{	hero.UseItem(selection); EnemiesTurn = 0; }
				
			}
			blit( backup, framebuf, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT);
			activeCharacter = 0;
			optionSelected = 0;
			option = 0; 
			whoToAttack = 0;
			
			if (enemies.GetHP() == 0)
			{
				Finish = true;	vsync();
				blit(framebuf, screen, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT); // Is this okay, is there missing info at all?
				textout_centre(screen, font , "You Win!", SCREEN_WIDTH/2, SCREEN_HEIGHT/2, textColor );
				sleep(1);
			}
			
		}	
		}
	}
	// battle is over
	if (enemies.GetHP() == 0)
	{ // player won!
		//fade_out(2);
		
		// draw status screen
				
		// get your experience, items and $$
		int goldin = enemies.GetGold();
		int expin  = enemies.GetExperience();
		
		string expstr = itoa(expin) + " Experience!";
		string gldstr = itoa(goldin) + " Gold!";
		
		vector<string> dialogArray;
		dialogArray.push_back(" CONGRATULATIONS!!  YOU WON!! ");
		TextBox(dialogArray,SCREEN_WIDTH/4,SCREEN_HEIGHT/3);
		dialogArray.clear();
		while (!key[ACTION_KEY]) vsync();
		while (key[ACTION_KEY]) vsync();
		dialogArray.push_back("          Battle Summary          ");
		dialogArray.push_back(" ");
		dialogArray.push_back("  You gained " + expstr);
		dialogArray.push_back("  You took " + gldstr);
		TextBox(dialogArray,SCREEN_WIDTH/4,SCREEN_HEIGHT/3);
		
		
		while (!key[ACTION_KEY]) vsync();
		while (key[ACTION_KEY]) vsync();
		
		
		
		hero.AddGold(goldin);
		hero.AddExperience(expin);
		// end add to char
		
		blit(framebuf, screen, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
		//fade_in(default_palette, 2);
		while (!key[ACTION_KEY]) vsync();
		while (key[ACTION_KEY]) vsync();
		//fade_out(2);
		//fade_in(default_palette, 2);
	}
	else
	{ // player lost
		blit(framebuf, screen, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT); // Is this okay, is there missing info at all?
		textout_centre(screen, font , "You LOST!", 90, 20, textColor );
		//fade_out(1);	
	}
	destroy_bitmap(backdrop);
	destroy_bitmap(backup);
}