// Character.h

// Your character should be global

#ifndef __CHARACTER__
#define __CHARACTER__
#include <string>
#include <multiset.h>
#include <multimap.h>
#include <vector>

class Person;
class Enemy;
class Hero;

typedef multiset<string> itemList;

extern vector<Enemy> enemyList;

typedef class Person
{
	public:
		Person();
		int sprite; //enemy sprite		
		void SetStrength(int value);
		int GetStrength();
		void SetDefense(int value);
		int GetDefense();
		void SetHP(int points);
		void SetMP(int points);
		void SetMaxHP(int points);
		void SetMaxMP(int points);
		int GetHP();
		int GetMP();
		int GetMaxHP();
		int GetMaxMP();
		int defend(int attackValue); // returns the total damage taken from the attack
		int attack(); // returns the total attack value
		// dialog?
	private:
		int Strength;	//private?? PROTECTED???
		int Defense;	//private?? Won't inherit will it? protected!!
		int MaxHP;		// needs to be protected with a function to increase/decrease
		int MaxMP;		// needs to be protected with a function to increase/decrease
		int HP, MP;
		
};

typedef class Enemy : public Person  // These should have predetermined values of HP And MP
{
	public:
		Enemy(); // constructor could take a value
		Enemy(string nm, int gld, int exp, int hp, int mp, int str, int def, itemList itms);
		Enemy(string nm, int gld, int exp, int hp, int mp, int str, int def);
		string GetName();
		int GetExperience();
		int GetGold();
		int guy;	
	private:
		string name;
		int gold, experience;  //this is what you win
		itemList items;        // same
};
typedef void (*pt2Function)();
typedef void (*ptr2func)();

typedef class Hero : public Person
{
	public:
		Hero();
		Hero(int hpin, int mpin, int levelin, int exp, const char * namein);
		int guy;
		void AddExperience(int exp);
		//int InitializeSetExperience(int exp, int levelIn, bool verify); // Only for init.
		itemList GetItems();
		int GetLevel();
		int GetGold();
		int GetExperience();
		void AddItem(string);
		bool UseItem(string);
		void AddGold(int a);
		bool UseGold(int a);
		string GetName();
	private:
		int experience;
		int level;
		int gold;
		string name;
		itemList items;
		multimap<string, ptr2func> use; // function pointer
		void initItems();
};
#endif