#include <allegro.h>

#include "palette.h"
#include <iostream.h>
#include "map.h"
#include "battle.h"
#include "gameconsts.h"
#include "optionsMenu.h"
#include "dialogBox.h"
#include <vector> 
#include "testingstuff.h" // becuase of talk2Girl/Guy test functions
#include "shop.h"


// Globals (defed as extern)
Hero hero;
int mapOriginX, mapOriginY;
int X, Y;
char direction;
int attackProb[512] = {1};//{0,2,1,2,2,2,2,2,2,2};
pt2Function mapAction[10];
DATAFILE* data;
BITMAP* backdrop, *framebuf;
BITMAP * mainMap;

vector<Enemy> enemyList;

void enemyInit()
{   //string name, int gold, int exp, hp, mp, itemList itms);
	enemyList.push_back(Enemy("Blue Blob", 20, 4, 9, 0, 2, 3));
	enemyList.push_back(Enemy("Skeleton", 45, 10, 20, 0, 3, 4));
	enemyList.push_back(Enemy("Warrior", 60, 30, 30, 0, 6, 4));
	for (int i = 0; i < 512; i++) attackProb[i] = 6; // NEEDS TO BE ELSEWHERE
}


// End GLobals
/// x - 10 , y - 7
void IntroForestToMap()
{
	while (key[ACTION_KEY]) vsync();
	X = 27*32;	Y = 107*32;
	mapOriginX = 10*32;	mapOriginY = 100*32;
}
void MapToCity1()
{
while (key[ACTION_KEY]) vsync();
	
	X = 17*32; Y = 31*32;
	mapOriginX = 7*32; mapOriginY = 18*32;
}
void MapToCity2()
{
while (key[ACTION_KEY]) vsync();
	
	X = 51*32; Y = 31*32;
	mapOriginX = 41*32; mapOriginY = 24*32;
}
void MapToCity3()
{
while (key[ACTION_KEY]) vsync();
	
	X = 95*32; Y = 12*32;
	mapOriginX = 85*32; mapOriginY = 5*32;
}
void CastleToKing()
{
while (key[ACTION_KEY]) vsync();
	
	X = 108*32; Y = 13*32;
	mapOriginX = 98*32; mapOriginY = 3*32;
}


void KingToCastle()
{
while (key[ACTION_KEY]) vsync();
    X = 23*32; Y = 1*32;
    mapOriginX = 13*32; mapOriginY=0;
}

void City1ToMap()
{
while (key[ACTION_KEY]) vsync();
	
	X = 4*32; Y = 121*32;
	mapOriginX = 1*32; mapOriginY = 114*32;
}
void City2ToMap()
{
while (key[ACTION_KEY]) vsync();
	
	X = 5*32; Y = 39*32;
	mapOriginX = 1*32; mapOriginY = 32*32;
}
void City3ToMap()
{
while (key[ACTION_KEY]) vsync();
	
	X = 36*32; Y = 120*32;
	mapOriginX = 26*32; mapOriginY = 114*32;
}

int initializeGame()
{
	set_color_depth(24);
/// Required setup stuff

	
	mapOriginX = 98*32; mapOriginY = 18*32;
	X=3552; Y=960;
	direction= 'e';
	text_mode(-1); // IMPORTANT!!!!!!!!!!!!!!!!!!!!!!!MUST INIT THIS

	allegro_init();
	install_keyboard();
	initialise_joystick();
	
	mapAction[2] = talk2Girl;
	mapAction[19] = talk2Girl2;
	
	mapInformation[105][30] = 18;
	mapAction[2] = MapToCity1;
	mapAction[8] = MapToCity2;
	mapAction[10] = MapToCity3;
	mapAction[4] = CastleToKing;
	mapAction[5] = KingToCastle;
	mapAction[3] = City1ToMap;
	mapAction[9] = City2ToMap;
	mapAction[11]= City3ToMap;
	mapAction[6] = IntroForestToMap;
	mapAction[12]= testShop;
	mapAction[13]= testShop;
	mapAction[14]= testShop;
	mapAction[15]= talk2King;
	mapAction[16]= talk2Sidekick;
	mapAction[17]= talk2Bridgeguard;
	mapAction[18]= talk2Girl;
	
	data = load_datafile("palette.dat"); // must be the correct name
	if (data == 0)
	{ 
			exit(1);
	} // ERROR MESSAGE
	//////  WINDOWS-->_FULLSCREEN
	set_gfx_mode(GFX_AUTODETECT, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0);
	set_palette((RGB*)data[mainPalette].dat);
	
	mainMap = load_bitmap("Tiles3.bmp", default_palette); // global should be currentMap though
// 		^^ THis is a dynamic color mode ^^
//             
//           |           |
//          \ /         \ /  THIS IS HOW TO DO IT CORRECTLY WITH dat files 
//	mainMap = create_bitmap(160, 32); // for now!!
//	clear_bitmap(mainMap);
//	cout << data[map].size << endl;
//	cout << data[map].type << endl;
//	blit((BITMAP*)data[map].dat, mainMap, 0,0,0,0,160, 32);


	//if (mainMap == 0) { exit(1);} // ERROR MESSAGE

//                       |	  |
//  HOW TO USE THE data \ /  \ /	
//	draw_sprite(screen,(BITMAP *)data[map].dat,  0,0); 
//	sleep(2);

// Can be elsewhere	
	backdrop=create_bitmap(MAPSIZE_X*32, MAPSIZE_Y*32);

	int numTilesWide = MAPSIZE_X ;
	int numTilesHigh = MAPSIZE_Y ;

/// Build the map code
// 		This code will build the entire map for the main map area
		
	for (int tX = 0; tX < numTilesWide; ++tX) 
		for (int tY = 0; tY < numTilesHigh; ++tY)
		{	
			int px = (mapTileData[tX][tY])%10; // 10 wide
			
			int py = (mapTileData[tX][tY]-px+1) / 10; 
			if (px == 0) { px = 10; py--; } 
			blit(mainMap, backdrop, (px)*32-32, py*32, tX*32, tY*32, 32, 32);
			//textout(backdrop, font, itoa(mapTileData[tX][tY]).c_str(), tX*32, tY*32, 1000 );
		}//		//		//		//	//MainMaposition X         Y  screenX  Y     Size
	
/// End map build

	// blit the map to the screen at position startX, startY
	blit(backdrop, screen, mapOriginX, mapOriginY, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT); // put background on screen
	framebuf=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);
	clear(framebuf);
	
	//Init Enemies
	enemyInit();

	// INit Character
	hero = Hero(30,10,1, 1,"Zelig");
	hero.SetStrength(3);
	return true;
}

int initializeSavedGame()
{
	initializeGame();
	// try to load saved game, checksum?
	//    if success true
	//    else fail
	return true;
}