// Options menu.
#include <allegro.h>
#include "gameconsts.h"
#include "optionsMenu.h"
#include "dialogBox.h"
#include <string>
#include <math.h>
#include "battle.h"

string itoa(int input)
{
	string out;
	while (input >= 10)
	{
		out = (char)( (input%10) + 48) + out;
		input = input/10;
	}
	out = (char) (input + 48) + out;
	return out;
}

void optionsMenu()
{
	vector<string> dialogArray;
	
	// draw initial menu screen
	for (int aY=0; aY<192; aY++) hline(framebuf, 0, aY, SCREEN_WIDTH, (aY/2)+128);
	for (int aY=192; aY<SCREEN_HEIGHT; aY++) hline(framebuf, 0, aY, SCREEN_WIDTH, ((aY-128)/2)+SCREEN_HEIGHT);
	blit(framebuf, screen, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	
	// Get info to output to screen
	string HP, MP, maxHP, maxMP, strength, defense;
	string name, currlevel, nextlevelexp, experience, gold;
	name = hero.GetName();
	currlevel = itoa(hero.GetLevel());
	nextlevelexp = itoa(pow(2, hero.GetLevel()) * 10);
	experience = itoa(hero.GetExperience());
	gold=itoa(hero.GetGold()); 
	HP = itoa(hero.GetHP());
	MP = itoa(hero.GetMP());
	maxHP = itoa(hero.GetMaxHP());
	maxMP = itoa(hero.GetMaxMP());
	strength = itoa(hero.GetStrength());
	defense = itoa(hero.GetDefense());
	
	dialogArray.push_back("               STATS:                 ");
	dialogArray.push_back("    " + name + " the great");
	dialogArray.push_back("");
	dialogArray.push_back("    Current Level : " + currlevel);
	dialogArray.push_back("    Experience    : " + experience);
	dialogArray.push_back("    Next level    : " + nextlevelexp);
	dialogArray.push_back("    Gold          : " + gold);
	dialogArray.push_back("");
	dialogArray.push_back("    Hit points    : " + HP + "/" + maxHP);
	dialogArray.push_back("    Mana points   : " +  MP + "/" + maxMP);	
	dialogArray.push_back("    Strength      : " + strength);
	dialogArray.push_back("    Defense       : " + defense);
	TextBox(dialogArray,180,80);
	dialogArray.clear();

// output Inventory option text box
    dialogArray.push_back("Press 'I' to use an Item.");
    TextBox(dialogArray,20,450);
    dialogArray.clear();


// output continue text box
	dialogArray.push_back("Press Action Key to Continue!");
	TextBox(dialogArray,380,450);
	dialogArray.clear();	
	
	while (!key[ACTION_KEY])
	{
	  if (key[KEY_I])
	  {
		BITMAP* backup = create_bitmap(SCREEN_HEIGHT, SCREEN_WIDTH);
		blit(framebuf, backup, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT);
		
	    //***Launch Inventory box here***
	    string selec = inventoryBox();
		if (selec != "") 
		{	hero.UseItem(selec);}
		blit( backup, framebuf, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT);
		blit( backup, screen, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT);
	  	while (key[KEY_I]) vsync();
	  }vsync();
	}
	//while (key[ACTION_KEY]) vsync();
	
}